<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "data_source".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DataSource".
 *
 * Columns in table "data_source" available as properties of the model,
 * followed by relations of table "data_source" available as properties of the model.
 *
 * @property integer $id
 * @property integer $data_source_type_id
 * @property string $name
 * @property string $description
 * @property integer $enabled
 * @property string $sort_order
 *
 * @property DataSourceType $dataSourceType
 * @property DataSourceEntityMatch[] $dataSourceEntityMatches
 * @property ProductElementSourceConfidence[] $productElementSourceConfidences
 */
abstract class BaseDataSource extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'data_source';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DataSource|DataSources', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('id, data_type_id, sort_order', 'required'),
            array('id, data_type_id, enabled', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>45),
            array('sort_order', 'length', 'max'=>2),
            array('description', 'safe'),
            array('name, description, enabled', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, data_type_id, name, description, enabled, sort_order', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'dataSourceType' => array(self::BELONGS_TO, 'DataSourceType', 'data_source_type_id'),
            'dataSourceEntityMatches' => array(self::HAS_MANY, 'DataSourceEntityMatch', 'data_source_id'),
            'productElementSourceConfidences' => array(self::HAS_MANY, 'ProductElementSourceConfidence', 'data_source_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'data_source_type_id' => null,
            'name' => Yii::t('app', 'Name'),
            'description' => Yii::t('app', 'Description'),
            'enabled' => Yii::t('app', 'Enabled'),
            'sort_order' => Yii::t('app', 'Sort Order'),
            'dataSourceType' => null,
            'dataSourceEntityMatches' => null,
            'productElementSourceConfidences' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('data_source_type_id', $this->data_source_type_id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('enabled', $this->enabled);
        $criteria->compare('sort_order', $this->sort_order, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
